.\" /*
.\"  * Revision Control Information
.\"  *
.\"  * $Source: /projects/hwsw/hwsw/common/src/polis/polis_lib/help/ptl2shift.man,v $
.\"  * $Author: luciano $
.\"  * $Revision: 1.1 $
.\"  * $Date: 1996/08/17 00:32:41 $
.\"  *
.\"
.TH PTL2SHIFT 1CAD "1 August 1994"
.SH NAME
ptl2shift \- Extract Ptolemy database netlists and parameters
.SH SYNOPSIS
.B ptl2shift [options] cell_name
.SH DESCRIPTION
\fBptl2shift\fR extracts a netlist in the auxiliary file format
used by \fIstrl2shift\fP from the Ptolemy database. It can also be used to
print out implementation setting commands for \fIpolis\fP, or to print out
parameter values for successive update using \fIptlconst\fP.
.SH OPTIONS
.B -A
writes the netlist in the auxiliary file format to standard output.
.PP
.B -I
writes two \fIset_impl\fP commands to standard output. These commands can be
used inside \fIpolis\fP (e.g., by redirecting the output to a file and then
sourcing that file after \fIread_shift\fP) to change the implementation 
of netlist components without
performing the netlisting process from scratch.
.PP
.B -P 
writes out star and galaxy parameters in a format that is suitable for
processing by \fIptlconst\fP, in order to update the parameters under shell
control.
.PP
.B -i
ignores the specified cells or property names when performing a function
(e.g., to skip Ptolemy output display cells when netlisting).
.SH "SEE ALSO"
ptlconst, polis, strl2shift
.SH AUTHORS
Luciano Lavagno
.SH BUGS
.SH COMMENTS
