.\" /*
.\"  * Revision Control Information
.\"  *
.\"  * $Source: /projects/hwsw/hwsw/common/src/polis/polis_lib/help/strl2shift.man,v $
.\"  * $Author: luciano $
.\"  * $Revision: 1.3 $
.\"  * $Date: 1996/07/15 17:00:29 $
.\"  *
.\"
.TH STRL2SHIFT 1CAD "1 August 1994"
.SH NAME
strl2shift \- Translator from Esterel to SHIFT
.SH SYNOPSIS
.B strl2shift [options] [input_file ...]
.SH DESCRIPTION
\fBstrl2shift\fR translates input files written in Esterel into one or more
output files written in SHIFT. It can also load multiple input files, written
in SHIFT and Esterel, into a single SHIFT file. 
File types are identified by extension: names ending in .strl imply
Esterel source code; names ending in .cfsm or .shift imply SHIFT code; names
ending in .aux imply auxiliary files (defining constants, types and netlists).
.SH OPTIONS
.TP 8
.B -n
Use the standard esterel compiler for the translation, instead of the (buggy)
e2s, s2s, a2n suite.
.TP 8
.B -a
Compile each file with extension .strl into a single file with extension .shift.
.TP 8
.B -c
Compile each file with extension .strl into a single file 
with extension .cfsm. The two options \fB-a\fR and
\fB-c\fR have the same behavior except for the output file name.
Both inhibit the final loading phase, when the .aux file is translated into a
SHIFT netlist, and concatenated with all the .shift, .cfsm files given on the
command line or produced from .strl files.
.TP 8
.B -o output_file
Changes the name of the output file from the default (changing the extension
from .strl to .cfsm or .shift
if \fB-a\fR or \fB-c\fR are present, changing the extension from .aux to .shift
otherwise).
.TP 8
.B -i number
Specifies the number of values of the Esterel integer type (by default 32768,
which means signed 16 bit).
.TP 8
.B -I number
Specifies the number of bits of the Esterel integer type (by default signed 16
bit; can be used only with \fB-n\fR).
.SH "SEE ALSO"
oc2shift, sis(1CAD).
.SH AUTHORS
Luciano Lavagno
.SH BUGS
.SH COMMENTS
