#/usr/awk -f

BEGIN {
   last_symbol = 0;
}

{
   insert = 1;
   if ((NF)&&($1!="/*")) {
       for (i=0; i<last_symbol; i++) {
          if (glob_symbol[i] == $2) {
             insert = 0;
             break;
          }
      }
      if (insert) {
         glob_symbol[last_symbol] = $2;
         type_symbol[last_symbol] = $1;
         last_symbol ++;
      }
   }
   else {
      print;         #leave unchanged the first lines of comments
   }
}

END {
   for (i=0; i<last_symbol; i++)
       printf("%s %s\n", type_symbol[i], glob_symbol[i]);
}
