/* This file should be copied locally and filled in with any user-defined 
 * type declarations (no functions or procedures). It is enclosed in every 
 * single compiled CFSM file.
 * Please, follow the enclosed sample template for complex integer numbers
 * (see also loc_types.h).
 */
#ifdef DUMMY_SAMPLE

/* some complex type defined as a pair of integers */
typedef struct {
	int r, i;
} complex;

/* parsing functions (in loc_types.c)  */
extern void init_complex ();
extern char *format_complex ();
extern void parse_complex ();

/* access functions for fields, to be used in Esterel */
#define GET_REAL(c) ((c).r)
#define GET_IMAG(c) ((c).i)
#define SET_REAL(c,v) ((c).r = (v), (c))
#define SET_IMAG(c,v) ((c).i = (v), (c))
#define SET_COMPLEX(c,v1,v2) ((c).r = (v1), (c).i = (v2), (c))
#endif /*DUMMY_SAMPLE*/


