/*
****************************************************************
BEGIN STATIC PRIORITY non-preemptive scheduling routines 
****************************************************************
*/


int
scheduler()
{
#define proc p
   int p = 0;
#define TASK_LIST N_PROCS


#include "simul_0.h"

   while (1) {

#include "simul_1.h"

#ifdef ESTEREL
#ifdef TICK_DEFAULT
      do {
	 test_tick = 0;
         emit_tick();
#endif /*TICK_DEFAULT*/
#endif /*ESTEREL*/

#include "simul_2.h"

         for(p=0; p<TASK_LIST; p++) {

            if(is_ready(p)) {

#ifdef DO_DELAY
               _begin_task (proc);
#endif /*DO_DELAY*/
#include "simul_3.h"
#ifdef DO_DELAY
               _end_task (proc);
#endif /*DO_DELAY*/
               p = -1; /* i.e. start a new search for a ready task */

            }
         }
#ifdef ESTEREL
#ifdef TICK_DEFAULT
      } while (test_tick);
#endif /*TICK_DEFAULT*/
#endif /*ESTEREL*/
   }
}


/*
****************************************************************
END STATIC PRIORITY non-preemptive scheduling routines 
****************************************************************
*/
