/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 Cadence Berkeley Labs, Cadence Design Systems Inc.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL CADENCE BERKELEY LABS BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF CADENCE
  BERKELEY LABS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  CADENCE BERKELEY LABS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND CADENCE BERKELEY LABS HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/

/*
********************************************
BEGIN default type FILE
********************************************
*/

/* should update also s2c_check_int in s2c_util.c when any of these changes */
typedef int  NOTYPE;
typedef int  int32bit; 
typedef short int int16bit; 
typedef char int8bit; 
typedef unsigned long int  unsigned_int32bit;
typedef unsigned short int  unsigned_int16bit;
typedef unsigned char unsigned_int8bit;  

typedef void __IT_type;

/* support for floating point and integer types */
#define _FLOAT(a) ((float) (a))
#define _DOUBLE(a) ((double) (a))

#define init_unsigned_int8bit init_int
#define init_int8bit init_int
#define init_unsigned_int16bit init_int
#define init_int16bit init_int
#define init_unsigned_int32bit init_int
#define init_int32bit init_int

#define format_unsigned_int8bit format_int
#define format_int8bit format_int
#define format_unsigned_int16bit format_int
#define format_int16bit format_int
#define format_unsigned_int32bit format_int
#define format_int32bit format_int

/* macros and type definitions for user-defined types */
#include <loc_types.h>

/*
********************************************
END default type FILE
********************************************
*/
