static const char file_id[] = "DEfrc.pl";
// .cc file generated from DEfrc.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEfrc.h"
#include "InfString.h"

const char *star_nm_DEfrc = "DEfrc";

const char* DEfrc :: className() const {return star_nm_DEfrc;}

ISA_FUNC(DEfrc,DEPolis);

Block* DEfrc :: makeNew() const { LOG_NEW; return new DEfrc;}

# line 189 "DEfrc.pl"
#define DO_ESTIMATE  (do_estimate=1)
#define DO_NOT_ESTIMATE  (do_estimate=0)
#define illegal_cpu() 0
#define FUZZY(n,d) {if ((frc_Star->needsSharedResource)&&(do_estimate)) { \
                     _delay += _cache_delay[n]?_cache_delay[n]:_cache_delay[n]=frc_Star->FuzzyDelay(d); \
                 }}
#define ENERGY(e)
#define DELAY(d) {if ((frc_Star->needsSharedResource)&&(do_estimate)) {_delay += (d);}}
/* Input event macros */
#define detect_e_ECLK_to_z_frc_0 frc_Star->e_ECLK_flag
/* Output event macros */
#define emit_e_TCLK() frc_Star->emitEventToIntQ( e_TCLK, _delay )
#define startup( p )
#define cleanup( p, e ) frc_Star->CleanUp( e )
#define always_cleanup( p ) frc_Star->CleanUp( 1 )
#define cpu frc_Star->resourceId
#define SET_LT(a,b) frc_Star->Set_LT((a),(b))
/* Settable constant macros */
#define v_MAXCOUNT frc_Star->c_MAXCOUNT
#define v_SIMSCALE frc_Star->c_SIMSCALE
#define v_PRESCALER frc_Star->c_PRESCALER
/* State and output variable macros */
#define v__st frc_Star->_st
#define v_COUNT frc_Star->COUNT
#define v_SCALE frc_Star->SCALE
    DEfrc * frc_Star = NULL;
    static int do_estimate = 1;
    static double _delay = 0.0;
    static double _cache_delay[14];
    /* Output event constants */
    static const int e_TCLK = 1;
    /* Input variable declarations */
    /* Output variable declarations */
    static int v_TCLK;

    static unsigned int path_id;
#include "z_frc_0.c"

DEfrc::DEfrc ()
{
	setDescriptor("Free Running Counter.\n    Input e_ECLK is a float representing the\n    period of the Free Running Counter in\n    milliseconds.");
	addPort(e_ECLK.setPort("e_ECLK",this,FLOAT));
	addPort(e_TCLK.setPort("e_TCLK",this,INT));
	addState(implem.setState("implem",this,"{implem}","Valid values: HW SW BEHAV"));
	addState(resourceName.setState("resourceName",this,"Resource1","resource to be used for simulation"));
	addState(Clock_freq.setState("Clock_freq",this,"Clock_freq","CPU Clock frequency"));
	addState(policy.setState("policy",this,"{SCHEDULER}","Scheduling Policy to be used for simulation"));
	addState(Priority.setState("Priority",this,"0","Priority: 0 -> lower"));
	addState(firename.setState("firename",this,"{Firingfile}","File to write firing information",
# line 82 "DEfrc.pl"
A_NONSETTABLE));
	addState(overname.setState("overname",this,"{Overflowfile}","File to write overflow information",
# line 89 "DEfrc.pl"
A_NONSETTABLE));
	addState(MAXCOUNT.setState("MAXCOUNT",this,"MAXCOUNT","Maximum value of the FRC counter"));
	addState(SIMSCALE.setState("SIMSCALE",this,"1","Scale down simulation (only for HW and SW)"));
	addState(PRESCALER.setState("PRESCALER",this,"1","Prescaler of the FRC"));

# line 112 "DEfrc.pl"
delayType = TRUE;
    _delay = 0.0;
}

void DEfrc::begin() {
# line 247 "DEfrc.pl"
char stemp[ 1024 ];
    InfString name;
    int saveimpl;

    if ( needsSharedResource < 2 ) {
      priority = Priority;
      frc_Star = this;
      /* set variables which reflect Star parameters*/ 
      strcpy( stemp, policy); 
      schedPolicy = resourcePointer->getSchedPolicy( stemp );
      sprintf( stemp, "%d", priority );
      lastFiredPr = resourcePointer->registerPriority( stemp );
      clkFreq = Clock_freq;
      clkFreq = (1000000.0)*clkFreq;
      resourcePointer->registerClock( clkFreq );
      totnf = 1.0/clkFreq;
      emittedEvents = new SequentialList();
      storeList = new SequentialList();
      _delay = 0.0;
      int i;
      for ( i=0; i<=13; i++ ) {
         _cache_delay[i] = 0;
      }
      /* State and output variables initialization */
      _st = 0;
      /* Settable constants initialization */
      c_MAXCOUNT = MAXCOUNT;
      c_SIMSCALE = SIMSCALE;
      c_PRESCALER = PRESCALER;
      /* Input event flag initialization */
      e_ECLK_flag = 0;
      if ( needsSharedResource ) {
        strcpy( stemp, resource );
        if (strchr(stemp, '.')) *(strchr(stemp,'.')) = '\0';
        if (( resourceId = (int) ReadCostParam( stemp )) == -1 ) {
          strcat( stemp, ": not a valid CPU" );
          Error::abortRun( *this, stemp );
        }
      }
      strcpy( stemp, firename );
      if (strcmp(stemp,"{Firingfile}")) fpfire = DERCStar::Openfiring(stemp);
      strcpy( stemp, overname );
      if (strcmp(stemp,"{Overflowfile}")) fpover = DERCStar::Openoverflow(stemp);
      now = -1.0;
      saveimpl = needsSharedResource;
      needsSharedResource = 0;
      _t_z_frc_0(0,0);

      needsSharedResource = saveimpl;
    } else if ( needsSharedResource == 2 ) {
      started = 0;
    } else {
      strcpy( stemp, "Implementation not supported!" );
      Error::abortRun( *this, stemp );
    }
}

void DEfrc::setup() {
# line 228 "DEfrc.pl"
DETarget *t;
    char stemp[1024];

    t = (DETarget *) target();
    if (!(t->isResource())) {
      strcpy( stemp, "Please, set target to Resource Contention Scheduler" );
      Error::abortRun( *this, stemp );
    }
    timeOfArrival = -1;
    _nextf = 1.0;
    _latency = 1.0;
    DERCStar::Closeflow();
    strcpy(resource, resourceName);
    strcpy(stemp, implem);
    needsSharedResource = getImplem( stemp );
    if ( needsSharedResource < 2 ) {
    }
}

void DEfrc::go() {
# line 304 "DEfrc.pl"
char stemp[ 1024 ];
    int runflag = 0;
    StringList name;
    
    now = arrivalTime;
    if ( needsSharedResource < 2 ) {
      name = Block::fullName();
      frc_Star = this;
      if (feedbackIn->dataNew && (int)((*feedbackIn)%0) == 0) {
          DERCStar* starUsingResource = resourcePointer->getTopCell()->star;
          if (((StarLLCell*)emittedEvents->head())->time != now ) {
              refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0);
          } else {
              if ( starUsingResource != this ) {
                  Error::abortRun( *this, "Star should not reach this point if preempted!" );
              }
              if(emittedEvents->head() == emittedEvents->tail() ) {
                  // This is the dummy event indicating end of resource usage 
                  resourcePointer->removeFinishedStar(this); 
                  emittedEvents->getAndRemove(); 
                  assert(emittedEvents->getAndRemove() == 0); 
                  if ( fpfire ) {
                      sprintf( stemp, "%s: %f %d end %s\n", (const char*) name, now, priority, resource );
                      DERCStar::Printfiring( stemp );
                  }
              } else { 
                  StarLLCell *temp; 
                  while((temp = (StarLLCell*)emittedEvents->head())->time == now && (emittedEvents->head() != emittedEvents->tail()) ) { 
                      StarLLCell *temp = (StarLLCell*)emittedEvents->getAndRemove(); 
                      assert(now == temp->time); 
                      emitEvent(temp, now); 
                  } 
                  refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
              }
              feedbackIn->dataNew = FALSE;
          }
      } else { // This star is firing for the first time, and has resource if req 
          if ( e_ECLK.dataNew ) {
            e_ECLK_flag = 1;
            e_ECLK.dataNew = FALSE;
            runflag = 1;
          }

        // Read the input values 
        _delay = 0.0;
        if (runflag == 1) {
          _t_z_frc_0(0,0);

          // write to firing file 
          if ( fpfire ) {
              sprintf( stemp, "%s: %f %d start %s\n", (const char*) name, now, priority, resource );
              DERCStar::Printfiring( stemp );
          }
          if (needsSharedResource) emitEventToIntQ( 0, _delay );// emit dummy event 
          timeOfArrival = -1;// reset this as have finished this firing 
          if (needsSharedResource) refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
        }
      }
    } else if ( needsSharedResource == 2 ) {
      if ( !started ) {
        valuein = (e_ECLK)%0;
        e_TCLK.put( now ) << (int) (( valuein * 1000.0 * Clock_freq ) * (int) PRESCALER);
        started = 1;
      }
      while ( e_ECLK.dataNew ) e_ECLK.getSimulEvent();
    }
}


int DEfrc::emitEventToIntQ ( int outputPort, double delay )
{
# line 121 "DEfrc.pl"
static const int ce_TCLK = 1;
      double emitTime;
      OutDEPort* tl;
      if (needsSharedResource) {
           StarLLCell *temp = (StarLLCell*)storeList->getAndRemove();
           if (temp == 0) temp = new StarLLCell(-1, -1);
           emitTime = now + (delay/clkFreq);
           temp->time = emitTime;
           temp->outputPort = outputPort;
           emittedEvents->append(temp);
      } else {
           if (now < 0) emitTime = 0.0;
           else emitTime = now + (_latency/clkFreq);
           switch(outputPort) {
             case ce_TCLK:
                tl = & e_TCLK;
                tl->put(emitTime) << v_TCLK;
                break;
            default:
               break;
         }
      }
      return 1;
}


void DEfrc::emitEvent (StarLLCell* cell, double emitTime)
{
# line 152 "DEfrc.pl"
static const int ce_TCLK = 1;
      OutDEPort * tl;
      switch( cell->outputPort ) {
            case ce_TCLK:
                tl = & e_TCLK;
                tl->put(emitTime) << v_TCLK;
                break;
            default:
               break;
      }
      storeList->append(cell);
}


double DEfrc::getDelay ()
{
# line 171 "DEfrc.pl"
// need to add 1 clock cycle for SW stars so that dummy event is seen
      if (needsSharedResource) return (_delay)/clkFreq;// FIXME: a hack
      else return (totnf);
}


void DEfrc::CleanUp ( int emitted )
{
# line 183 "DEfrc.pl"
if ( emitted ) {
        e_ECLK_flag = 0;
      }
}


// prototype instance for known block list
static DEfrc proto;
static RegisterBlock registerBlock(proto,"frc");
