static const char file_id[] = "DEic.pl";
// .cc file generated from DEic.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEic.h"
#include "InfString.h"

const char *star_nm_DEic = "DEic";

const char* DEic :: className() const {return star_nm_DEic;}

ISA_FUNC(DEic,DEPolis);

Block* DEic :: makeNew() const { LOG_NEW; return new DEic;}

# line 185 "DEic.pl"
#define DO_ESTIMATE  (do_estimate=1)
#define DO_NOT_ESTIMATE  (do_estimate=0)
#define illegal_cpu() 0
#define FUZZY(n,d) {if ((ic_Star->needsSharedResource)&&(do_estimate)) { \
                     _delay += _cache_delay[n]?_cache_delay[n]:_cache_delay[n]=ic_Star->FuzzyDelay(d); \
                 }}
#define ENERGY(e)
#define DELAY(d) {if ((ic_Star->needsSharedResource)&&(do_estimate)) {_delay += (d);}}
/* Input event macros */
#define detect_e_IC_START_to_z_ic_0 ic_Star->e_IC_START_flag
#define detect_e_TCLK_to_z_ic_0 ic_Star->e_TCLK_flag
/* Output event macros */
#define emit_e_IC_END() ic_Star->emitEventToIntQ( e_IC_END, _delay )
#define startup( p )
#define cleanup( p, e ) ic_Star->CleanUp( e )
#define always_cleanup( p ) ic_Star->CleanUp( 1 )
#define cpu ic_Star->resourceId
#define SET_LT(a,b) ic_Star->Set_LT((a),(b))
/* Settable constant macros */
#define v_MAXCOUNT ic_Star->c_MAXCOUNT
#define v_N ic_Star->c_N
/* State and output variable macros */
#define v__st ic_Star->_st
    DEic * ic_Star = NULL;
    static int do_estimate = 1;
    static double _delay = 0.0;
    static double _cache_delay[7];
    /* Output event constants */
    static const int e_IC_END = 1;
    /* Input variable declarations */
    static int v_TCLK;
    /* Output variable declarations */
    static int v_IC_END;

    static unsigned int path_id;
#include "z_ic_0.c"

DEic::DEic ()
{
	setDescriptor("Input Capture");
	addPort(e_IC_START.setPort("e_IC_START",this,INT));
	addPort(e_TCLK.setPort("e_TCLK",this,INT));
	addPort(e_IC_END.setPort("e_IC_END",this,INT));
	addState(implem.setState("implem",this,"{implem}","Valid values: HW SW BEHAV"));
	addState(resourceName.setState("resourceName",this,"Resource1","resource to be used for simulation"));
	addState(Clock_freq.setState("Clock_freq",this,"Clock_freq","CPU Clock frequency"));
	addState(policy.setState("policy",this,"{SCHEDULER}","Scheduling Policy to be used for simulation"));
	addState(Priority.setState("Priority",this,"0","Priority: 0 -> lower"));
	addState(firename.setState("firename",this,"{Firingfile}","File to write firing information",
# line 83 "DEic.pl"
A_NONSETTABLE));
	addState(overname.setState("overname",this,"{Overflowfile}","File to write overflow information",
# line 90 "DEic.pl"
A_NONSETTABLE));
	addState(MAXCOUNT.setState("MAXCOUNT",this,"MAXCOUNT","Maximum value of the FRC counter"));
	addState(N.setState("N",this,"1","parameter N (range 1 to 4) identifies one of the 4 input captures"));

# line 107 "DEic.pl"
delayType = TRUE;
    _delay = 0.0;
}

void DEic::begin() {
# line 242 "DEic.pl"
char stemp[ 1024 ];
    InfString name;
    int saveimpl;

    if ( needsSharedResource < 2 ) {
      priority = Priority;
      ic_Star = this;
      /* set variables which reflect Star parameters*/ 
      strcpy( stemp, policy); 
      schedPolicy = resourcePointer->getSchedPolicy( stemp );
      sprintf( stemp, "%d", priority );
      lastFiredPr = resourcePointer->registerPriority( stemp );
      clkFreq = Clock_freq;
      clkFreq = (1000000.0)*clkFreq;
      resourcePointer->registerClock( clkFreq );
      totnf = 1.0/clkFreq;
      emittedEvents = new SequentialList();
      storeList = new SequentialList();
      _delay = 0.0;
      int i;
      for ( i=0; i<=6; i++ ) {
         _cache_delay[i] = 0;
      }
      /* State and output variables initialization */
      _st = 0;
      /* Settable constants initialization */
      c_MAXCOUNT = MAXCOUNT;
      c_N = N;
      /* Input event flag initialization */
      e_IC_START_flag = 0;
      e_TCLK_flag = 0;
      if ( needsSharedResource ) {
        strcpy( stemp, resource );
        if (strchr(stemp, '.')) *(strchr(stemp,'.')) = '\0';
        if (( resourceId = (int) ReadCostParam( stemp )) == -1 ) {
          strcat( stemp, ": not a valid CPU" );
          Error::abortRun( *this, stemp );
        }
      }
      strcpy( stemp, firename );
      if (strcmp(stemp,"{Firingfile}")) fpfire = DERCStar::Openfiring(stemp);
      strcpy( stemp, overname );
      if (strcmp(stemp,"{Overflowfile}")) fpover = DERCStar::Openoverflow(stemp);
      now = -1.0;
      saveimpl = needsSharedResource;
      needsSharedResource = 0;
      _t_z_ic_0(0,0);

      needsSharedResource = saveimpl;
    } else if ( needsSharedResource == 2 ) {
      start = 0;
      period = 0;
      ckfr = (double) Clock_freq;
    } else {
      strcpy( stemp, "Implementation not supported!" );
      Error::abortRun( *this, stemp );
    }
}

void DEic::setup() {
# line 223 "DEic.pl"
DETarget *t;
    char stemp[1024];

    t = (DETarget *) target();
    if (!(t->isResource())) {
      strcpy( stemp, "Please, set target to Resource Contention Scheduler" );
      Error::abortRun( *this, stemp );
    }
    timeOfArrival = -1;
    _nextf = 1.0;
    _latency = 1.0;
    DERCStar::Closeflow();
    strcpy(resource, resourceName);
    strcpy(stemp, implem);
    needsSharedResource = getImplem( stemp );
    if ( needsSharedResource < 2 ) {
    }
}

void DEic::go() {
# line 301 "DEic.pl"
char stemp[ 1024 ];
    int runflag = 0;
    StringList name;
    now = arrivalTime;

    if ( needsSharedResource < 2 ) {
      name = Block::fullName();
      ic_Star = this;
      if (feedbackIn->dataNew && (int)((*feedbackIn)%0) == 0) {
          DERCStar* starUsingResource = resourcePointer->getTopCell()->star;
          if (((StarLLCell*)emittedEvents->head())->time != now ) {
              refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0);
          } else {
              if ( starUsingResource != this ) {
                  Error::abortRun( *this, "Star should not reach this point if preempted!" );
              }
              if(emittedEvents->head() == emittedEvents->tail() ) {
                  // This is the dummy event indicating end of resource usage 
                  resourcePointer->removeFinishedStar(this); 
                  emittedEvents->getAndRemove(); 
                  assert(emittedEvents->getAndRemove() == 0); 
                  if ( fpfire ) {
                      sprintf( stemp, "%s: %f %d end %s\n", (const char*) name, now, priority, resource );
                      DERCStar::Printfiring( stemp );
                  }
              } else { 
                  StarLLCell *temp; 
                  while((temp = (StarLLCell*)emittedEvents->head())->time == now && (emittedEvents->head() != emittedEvents->tail()) ) { 
                      StarLLCell *temp = (StarLLCell*)emittedEvents->getAndRemove(); 
                      assert(now == temp->time); 
                      emitEvent(temp, now); 
                  } 
                  refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
              }
              feedbackIn->dataNew = FALSE;
          }
      } else { // This star is firing for the first time, and has resource if req 
          if ( e_IC_START.dataNew ) {
            e_IC_START_flag = 1;
            e_IC_START.dataNew = FALSE;
            runflag = 1;
          }
          if ( e_TCLK.dataNew ) {
            e_TCLK_flag = 1;
            e_TCLK.dataNew = FALSE;
            runflag = 1;
          }

        // Read the input values 
        v_TCLK = (e_TCLK)%0;
        _delay = 0.0;
        if (runflag == 1 ) {
          _t_z_ic_0(0,0);

          // write to firing file 
          if ( fpfire ) {
              sprintf( stemp, "%s: %f %d start %s\n", (const char*) name, now, priority, resource );
              DERCStar::Printfiring( stemp );
          }
          if (needsSharedResource) emitEventToIntQ( 0, _delay );// emit dummy event 
          timeOfArrival = -1;// reset this as have finished this firing 
          if (needsSharedResource) refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
        }
      }
    } else if ( needsSharedResource == 2 ) {
      if ( e_TCLK.dataNew ) {
          start = now;
          period = (e_TCLK)%0;
          while ( e_TCLK.dataNew ) e_TCLK.getSimulEvent();
      }
      if ( e_IC_START.dataNew ) {
          if ( period ) {
              total = (int) (( now - start ) * ckfr * 1000000.0 / (double) period ) % (int) MAXCOUNT;
              e_IC_END.put( now + 1/(ckfr*1000000.0)) << total;
          }
          while ( e_IC_START.dataNew ) e_IC_START.getSimulEvent();
      }
    }
}


int DEic::emitEventToIntQ ( int outputPort, double delay )
{
# line 116 "DEic.pl"
static const int ce_IC_END = 1;
      double emitTime;
      OutDEPort* tl;
      if (needsSharedResource) {
           StarLLCell *temp = (StarLLCell*)storeList->getAndRemove();
           if (temp == 0) temp = new StarLLCell(-1, -1);
           emitTime = now + (delay/clkFreq);
           temp->time = emitTime;
           temp->outputPort = outputPort;
           emittedEvents->append(temp);
      } else {
           if (now < 0) emitTime = 0.0;
           else emitTime = now + (_latency/clkFreq);
           switch(outputPort) {
             case ce_IC_END:
                tl = & e_IC_END;
                tl->put(emitTime) << v_IC_END;
                break;
            default:
               break;
         }
      }
      return 1;
}


void DEic::emitEvent (StarLLCell* cell, double emitTime)
{
# line 147 "DEic.pl"
static const int ce_IC_END = 1;
      OutDEPort * tl;
      switch( cell->outputPort ) {
            case ce_IC_END:
                tl = & e_IC_END;
                tl->put(emitTime) << v_IC_END;
                break;
            default:
               break;
      }
      storeList->append(cell);
}


double DEic::getDelay ()
{
# line 166 "DEic.pl"
// need to add 1 clock cycle for SW stars so that dummy event is seen
      if (needsSharedResource) return (_delay)/clkFreq;// FIXME: a hack
      else return (totnf);
}


void DEic::CleanUp ( int emitted )
{
# line 178 "DEic.pl"
if ( emitted ) {
        e_IC_START_flag = 0;
        e_TCLK_flag = 0;
      }
}


// prototype instance for known block list
static DEic proto;
static RegisterBlock registerBlock(proto,"ic");
