#ifndef _DEic_h
#define _DEic_h 1
// header file generated from DEic.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "uC_types.h"
#include "swlib.h"
#include "DETarget.h"
#include "DEPolis.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"

class DEic : public DEPolis
{
public:
	DEic();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void begin();
	InDEPort e_IC_START;
	InDEPort e_TCLK;
	OutDEPort e_IC_END;
# line 25 "DEic.pl"
double now;
    int resourceId;
    double clkFreq;
    /* Input event flags */
    int e_IC_START_flag;
    int e_TCLK_flag;
    /* Settable constants */
    int c_MAXCOUNT;
    int c_N;
    /* State and output variables */
    int _st;
	int emitEventToIntQ ( int outputPort, double delay );
	void emitEvent (StarLLCell* cell, double emitTime);
	double getDelay ();
	void CleanUp ( int emitted );

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState implem;
	StringState resourceName;
	FloatState Clock_freq;
	StringState policy;
	IntState Priority;
	StringState firename;
	StringState overname;
	IntState MAXCOUNT;
	IntState N;

private:
# line 38 "DEic.pl"
double *_time, totnf;
    double _nextf, _latency;
    FILE *fpfire;
    FILE *fpover;
    /* Variables for behavioural simulation */
    double start;
    double period;
    double ckfr;
    int total;

};
#endif
