#ifndef _DEoc_self_h
#define _DEoc_self_h 1
// header file generated from DEoc_self.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "uC_types.h"
#include "swlib.h"
#include "DETarget.h"
#include "DEPolis.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"

class DEoc_self : public DEPolis
{
public:
	DEoc_self();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void begin();
	InDEPort e_RESET;
	InDEPort e_TCLK;
	OutDEPort e_OC_END;
# line 25 "DEoc_self.pl"
double now;
    int resourceId;
    double clkFreq;
    /* Input event flags */
    int e_RESET_flag;
    int e_TCLK_flag;
    /* Settable constants */
    int c_SIMSCALE;
    int c_N;
    int c_OCPERIOD;
    int c_MAXCOUNT;
    /* State and output variables */
    int _st;
    int COUNT_OC;
	int emitEventToIntQ ( int outputPort, double delay );
	void emitEvent (StarLLCell* cell, double emitTime);
	double getDelay ();
	void CleanUp ( int emitted );

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState implem;
	StringState resourceName;
	FloatState Clock_freq;
	StringState policy;
	IntState Priority;
	StringState firename;
	StringState overname;
	IntState SIMSCALE;
	IntState N;
	IntState OCPERIOD;
	IntState MAXCOUNT;

private:
# line 41 "DEoc_self.pl"
double *_time, totnf;
    double _nextf, _latency;
    FILE *fpfire;
    FILE *fpover;
    /* Variables for behavioural simulation */
    double nextf;
    double ckfr;
    int ncycle;

};
#endif
