#ifndef _DEpwmfrc_h
#define _DEpwmfrc_h 1
// header file generated from DEpwmfrc.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "uC_types.h"
#include "swlib.h"
#include "DETarget.h"
#include "DEPolis.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"

class DEpwmfrc : public DEPolis
{
public:
	DEpwmfrc();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void begin();
	InDEPort e_ECLK;
	OutDEPort e_PWMCLK;
# line 21 "DEpwmfrc.pl"
double now;
    int resourceId;
    double clkFreq;
    /* Input event flags */
    int e_ECLK_flag;
    /* Settable constants */
    int c_PWMMAXCOUNT;
    int c_SIMSCALE;
    int c_PWMPRESCALER;
    /* State and output variables */
    int _st;
    int COUNT;
    int SCALE;
	int emitEventToIntQ ( int outputPort, double delay );
	void emitEvent (StarLLCell* cell, double emitTime);
	double getDelay ();
	void CleanUp ( int emitted );

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState implem;
	StringState resourceName;
	FloatState Clock_freq;
	StringState policy;
	IntState Priority;
	StringState firename;
	StringState overname;
	IntState PWMMAXCOUNT;
	IntState SIMSCALE;
	IntState PWMPRESCALER;

private:
# line 36 "DEpwmfrc.pl"
double *_time, totnf;
    double _nextf, _latency;
    FILE *fpfire;
    FILE *fpover;
    /* Variables for behavioural simulation */
    int emitted;
    int scaler;
    double valuein;

};
#endif
