static const char file_id[] = "DEmeasure_dc.pl";
// .cc file generated from DEmeasure_dc.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEmeasure_dc.h"

const char *star_nm_DEmeasure_dc = "DEmeasure_dc";

const char* DEmeasure_dc :: className() const {return star_nm_DEmeasure_dc;}

ISA_FUNC(DEmeasure_dc,DERepeatStar);

Block* DEmeasure_dc :: makeNew() const { LOG_NEW; return new DEmeasure_dc;}

DEmeasure_dc::DEmeasure_dc ()
{
	setDescriptor("Measure the DC value of a PWM signal.");
	addPort(IN.setPort("IN",this,INT));
	addPort(OUT.setPort("OUT",this,INT));
	addState(CONST_NORMALIZE.setState("CONST_NORMALIZE",this,"NORMALIZE","Normalization constant"));


}

void DEmeasure_dc::begin() {
# line 30 "DEmeasure_dc.pl"
waitone = 1;
        startone = 0;
        startzero = 0;
}

void DEmeasure_dc::go() {
# line 35 "DEmeasure_dc.pl"
now = arrivalTime;
        if ( IN.dataNew ) {
            val = (IN)%0;
            if ( waitone == 1 && val != 0 ) {
                if ( startone != 0 && startzero != 0 ) {
                    mean = (( startzero - startone ) / ( now - startone )) * 
                           (int) CONST_NORMALIZE - ((int) CONST_NORMALIZE / 2 );
                    OUT.put( now ) << mean;
                } else if ( startone == 0 && startzero != 0 ) {
                    OUT.put( now ) << 0;
                }
                startone = now;
                startzero = 0;
                waitone = 0;
            } else if ( waitone == 1 && val == 0 ) {
                if ( startone != 0 && startzero != 0 ) {
                    mean = (( startzero - startone ) / ( now - startone )) * 
                           (int) CONST_NORMALIZE - ((int) CONST_NORMALIZE / 2 );
                    OUT.put( now ) << mean;
                } else if ( startone == 0 && startzero != 0 ) {
                    OUT.put( now ) << 0;
                }
                startone = now;
                startzero = now;
                waitone = 1;
            } else if ( waitone == 0 && val == 0 ) {
                startzero = now;
                waitone = 1;
            } else {
                /* What the heck ???  */
            }
        }
}

// prototype instance for known block list
static DEmeasure_dc proto;
static RegisterBlock registerBlock(proto,"measure_dc");
