/* 
******************************************************************* 
BEGIN SW LIBRARY FOR uC *******************************************
******************************************************************* 
*/

#define   _ITE(i0, i1, i2)  ((i0)?(i1):(i2))
#define   _WIRE(i0)  (i0)
#define   _ADD(i0, i1)   ((i0)+(i1))
#define   _SUB(i0, i1)   ((i0)-(i1))
#define   _INC(i0)       ((i0)+1)
#define   _DEC(i0)       ((i0)-1)
#define   _GT(i0, i1)    ((i0)>(i1))
#define   _GE(i0, i1)    ((i0)>=(i1))
#define   _LT(i0, i1)    ((i0)<(i1))
#define   _LE(i0, i1)    ((i0)<=(i1))
#define   _EQ(i0, i1)    ((i0)==(i1))
#define   _NEQ(i0, i1)   ((i0)!=(i1))
#define   _AND(i0, i1)	 ((i0)&(i1))
#define   _OR(i0, i1)    ((i0)|(i1))
#define   _NOT(i0)       (~(i0))
#define   _NAND(i0, i1)  (~((i0)&(i1)))
#define   _NOR(i0, i1)   (~((i0)|(i1)))
#define   _XOR(i0, i1)   ((i0)^(i1))
#define   _XNOR(i0, i1)  (~((i0)^(i1)))
#define   _BOOL_AND(i0, i1)	 ((i0)&&(i1))
#define   _BOOL_OR(i0, i1)    ((i0)||(i1))
#define   _BOOL_NOT(i0)       (!(i0))
#define   _BOOL_NAND(i0, i1)  (!((i0)&&(i1)))
#define   _BOOL_NOR(i0, i1)   (!((i0)||(i1)))
#define   _BOOL_XOR(i0, i1)   ((i0)&&!(i1)||!(i0)&&(i1))
#define   _BOOL_XNOR(i0, i1)  (!((i0)&&!(i1)||!(i0)&&(i1)))
#define   _LSH(i0,i1)       ((i0)<<(i1))
#define   _LSH1(i0)       ((i0)<<1)
#define   _LSH8(i0)       ((i0)<<8)
#define   _RSH(i0,i1)       ((i0)>>(i1))      
#define   _RSH1(i0)       ((i0)>>1)      
#define   _RSH8(i0)       ((i0)>>8)      
     /*RSH may be 1 filled if it is declared signed*/
#define   _CPL2(i0)          ((~(i0))+1)
#define   _U_MINUS(i0)   (-(i0))
#define   _TIMES(i0, i1) ((i0)*(i1))
#define   _DIVIDE(i0, i1) ((i0)/(i1))
#define   _MOD(i0, i1)    ((i0)%(i1))
     /*machine dependent if negative*/

/* old stuff to be compatible */
#define   _MINUS(i0, i1) ((i0)-(i1))
#define   _MUL(i0, i1)   ((i0)*(i1))
#define   _TIME(i0, i1)   ((i0)*(i1))

/* 
******************************************************************* 
END SW LIBRARY FOR uC ********************************************* 
******************************************************************* 
*/
