BEGIN {
   false = "%false";
   true  = "%true";
   notr  = "%not reached";
}

/^name/     {name  = $2;}
/^memsize/  {memsize  = $2;}
/^Dina/     {memina   = $2;}
/^Addra/    {memaddra = $2;}
/^Douta/    {memouta  = $2;}
/^Dinb/     {meminb   = $2;} 
/^Addrb/    {memaddrb = $2;}
/^Doutb/    {memoutb  = $2;}
/^Side/     {Side     = $2;}

END {

    printf("module %s:",name);
    printf("\n\ninput  %s : integer,",memina);
    printf("\n       %s : integer,",memaddra);
    printf("\n       %s : integer,",meminb);
    printf("\n       %s : integer,",memaddrb);
    printf("\n       %s : boolean    %s : SIDE A",Side,false);
    printf("\n                         %s  : SIDE B",true);
    printf("\n;");
    printf("\noutput %s : integer,",memouta); 
    printf("\n       %s : integer",memoutb);
    printf("\n;");

    printf("\n\nvar    M0  : integer,");
    for (i=1; i<=memsize-2; i++)
       printf("\n       M%d  : integer,",i);
    printf("\n       M%d  : integer",i);
    printf("\nin");
    printf("\n   loop");
    printf("\n      do");
    printf("\n         loop");
    printf("\n            if (?SIDE=false) then");
    printf("\n               await %s;",memaddra);
    printf("\n               present %s then",memina);
    printf("\n                  if (?%s=0) then",memaddra);
    printf("\n                     M0 := ?%s;",memina);
    for (i=1; i<=memsize-1; i++) {
        printf("\n                  elsif (?%s=%d) then",memaddra,i);
        printf("\n                     M%d := ?%s;",i,memina);
        }
    printf("\n                  end if");
    printf("\n               else");
    printf("\n                  if (?%s=0) then",memaddra);
    printf("\n                     emit %s(M0)",memouta);
    for (i=1; i<=memsize-1; i++) {
        printf("\n                  elsif (?%s=%d) then",memaddra,i);
        printf("\n                     emit %s(M%d);",memouta,i);
        }
    printf("\n                  end if");
    printf("\n               end present");


    printf("\n            elsif (?SIDE=true) then");
    printf("\n               await %s;",memaddrb);
    printf("\n               present %s then",meminb);
    printf("\n                  if (?%s=0) then",memaddrb);
    printf("\n                     M0 := ?%s;",meminb);
    for (i=1; i<=memsize-1; i++) {
        printf("\n                  elsif (?%s=%d) then",memaddrb,i);
        printf("\n                     M%d := ?%s;",i,meminb);
        }
    printf("\n                  end if");
    printf("\n               else");
    printf("\n                  if (?%s=0) then",memaddrb);
    printf("\n                     emit %s(M0)",memoutb);
    for (i=1; i<=memsize-1; i++) {
        printf("\n                  elsif (?%s=%d) then",memaddrb,i);
        printf("\n                     emit %s(M%d);",memoutb,i);
        }
    printf("\n                  end if");
    printf("\n               end present");
    printf("\n            else");
    printf("\n               halt  %s",notr);
    printf("\n            end if;"); 
    printf("\n         end loop;");
    printf("\n      watching %s;",Side);
    printf("\n   end loop;");
    printf("\nend var;");
    printf("\nend module");
}
