BEGIN {
}

/^name/     {name  = $2;}
/^memsize/  {memsize = $2;}
/^Din/      {memin   = $2;}
/^Addr/     {memaddr = $2;}
/^Dout/     {memout  = $2;}

END {

    printf("module %s:",name);
    printf("\n\ninput  %s : integer,",memin);
    printf("\n       %s : integer",memaddr);
    printf("\n;");
    printf("\noutput %s : integer",memout); 
    printf("\n;");

    printf("\n\nvar    M0  : integer,");
    for (i=1; i<=memsize-2; i++)
       printf("\n       M%d  : integer,",i);
    printf("\n       M%d  : integer",i);
    printf("\nin");
    printf("\n   loop");
    printf("\n      await %s;",memaddr);
    printf("\n      present %s then",memin);
    printf("\n         if (?%s=0) then",memaddr);
    printf("\n            M0 := ?%s;",memin);
    for (i=1; i<=memsize-1; i++) {
        printf("\n         elsif (?%s=%d) then",memaddr,i);
        printf("\n            M%d := ?%s;",i,memin);
        }
    printf("\n         end if");
    printf("\n      else");
    printf("\n         if (?%s=0) then",memaddr);
    printf("\n            emit %s(M0)",memout);
    for (i=1; i<=memsize-1; i++) {
        printf("\n         elsif (?%s=%d) then",memaddr,i);
        printf("\n            emit %s(M%d);",memout,i);
        }
    printf("\n         end if");
    printf("\n      end present");
    printf("\n   end loop;");
    printf("\nend var;");
    printf("\nend module");
}
