/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 Cadence Berkeley Labs, Cadence Design Systems Inc.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL CADENCE BERKELEY LABS BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF CADENCE
  BERKELEY LABS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  CADENCE BERKELEY LABS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND CADENCE BERKELEY LABS HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/
/*
****************************************************************
BEGIN pre-run scheduler
****************************************************************
*/

int
scheduler()
{
   int proc = 0;
   int p = 0;



#include "simul_0.h"

   while (1) {


#ifdef TICK_DEFAULT
         __set_tick();
#endif /*TICK_DEFAULT*/

#include "simul_1.h"

         assign_events_to_proc_buffs();

#include "simul_2.h"

         for(p=0; p<TASK_LIST; p++) {
            proc = next_task_in_list[p];
            if(inp_event[proc] != 0) {

#ifdef DO_DELAY
               _begin_task (proc);
#endif /*DO_DELAY*/
#include "simul_3.h"
#ifdef DO_DELAY
               _end_task (proc);
#endif /*DO_DELAY*/

            }
         }

   }
}

/*
**************************************************************
END pre-run scheduler 
****************************************************************
*/
