/*
****************************************************************
BEGIN PREEMPTIVE scheduler 
****************************************************************
*/

#define IDLE_PRIORITY N_PROCS 

/* Global */
int current_priority;

void
sched_task(min_priority)
int min_priority;
{
   int proc;
   int p = 0;

   do {
     for(current_priority=0; current_priority<min_priority; 
          current_priority++) {
        proc = priority_to_task[current_priority];
        if(is_ready(proc)) {

#ifdef DO_DELAY
               _begin_task (proc);
#endif /*DO_DELAY*/
#include "simul_3.h"
#ifdef DO_DELAY
               _end_task (proc);
#endif /*DO_DELAY*/
               break;
        }
     }
   } while(current_priority<min_priority);

   return; 
}



int
scheduler()
{

#include "simul_0.h"

current_priority = IDLE_PRIORITY;


   while( 1 ) {
#include "simul_1.h"
 
#include "simul_2.h"

         sched_task( IDLE_PRIORITY);

   }
}



/*
****************************************************************
END PREEMPTIVE scheduler 
****************************************************************
*/
