/*************************************************************************

  Copyright   [Copyright (c) 1994-1996 Cadence Berkeley Labs, Cadence Design Systems Inc.
  All rights reserved.

  Permission is hereby granted, without written agreement and without license
  or royalty fees, to use, copy, modify, and distribute this software and its
  documentation for any purpose, provided that the above copyright notice and
  the following two paragraphs appear in all copies of this software.

  IN NO EVENT SHALL CADENCE BERKELEY LABS BE LIABLE TO ANY PARTY FOR
  DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
  OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF CADENCE
  BERKELEY LABS HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

  CADENCE BERKELEY LABS SPECIFICALLY DISCLAIMS ANY WARRANTIES,
  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN
  "AS IS" BASIS, AND CADENCE BERKELEY LABS HAS NO OBLIGATION TO PROVIDE
  MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.]

******************************************************************************/

/* parsing and printing functions for int and float */

int
init_int (i)
int i;
{
      return i;
}

float init_float (i)
int i;
{
      return i;
}

double init_double (i)
int i;
{
      return i;
}

#ifdef UNIX
char *
format_int (i)
int i;
{
      static char s[80];

      sprintf (s, "%d", i);
      return s;
}

void
parse_unsigned_int8bit (i, s)
unsigned_int8bit *i;
char *s;
{
      *i = atoi(s);
}

void
parse_unsigned_int16bit (i, s)
unsigned_int16bit *i;
char *s;
{
      *i = atoi(s);
}

void
parse_unsigned_int32bit (i, s)
unsigned_int32bit *i;
char *s;
{
      *i = atoi(s);
}

void
parse_int8bit (i, s)
int8bit *i;
char *s;
{
      *i = atoi(s);
}

void
parse_int16bit (i, s)
int16bit *i;
char *s;
{
      *i = atoi(s);
}

void
parse_int32bit (i, s)
int32bit *i;
char *s;
{
      *i = atoi(s);
}

char *
format_float (f)
double f;
{
      static char s[80];

      sprintf (s, "%g", f);
      return s;
}

void
parse_float (f, s)
float *f;
char *s;
{
      sscanf (s, "%g", f);
}

char *
format_double (f)
double f;
{
      static char s[80];

      sprintf (s, "%lg", f);
      return s;
}

void
parse_double (d, s)
double *d;
char *s;
{
      sscanf (s, "%lg", d);
}
#endif /*UNIX*/
