static const char file_id[] = "DEad_mult.pl";
// .cc file generated from DEad_mult.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEad_mult.h"
#include "InfString.h"

const char *star_nm_DEad_mult = "DEad_mult";

const char* DEad_mult :: className() const {return star_nm_DEad_mult;}

ISA_FUNC(DEad_mult,DEPolis);

Block* DEad_mult :: makeNew() const { LOG_NEW; return new DEad_mult;}

# line 265 "DEad_mult.pl"
#define DO_ESTIMATE  (do_estimate=1)
#define DO_NOT_ESTIMATE  (do_estimate=0)
#define illegal_cpu() 0
#define FUZZY(n,d) {if ((ad_mult_Star->needsSharedResource)&&(do_estimate)) { \
                     _delay += _cache_delay[n]?_cache_delay[n]:_cache_delay[n]=ad_mult_Star->FuzzyDelay(d); \
                 }}
#define ENERGY(e)
#define DELAY(d) {if ((ad_mult_Star->needsSharedResource)&&(do_estimate)) {_delay += (d);}}
/* Input event macros */
#define detect_e_AD_START_to_z_ad_mult_0 ad_mult_Star->e_AD_START_flag
#define detect_e_ECLK_to_z_ad_mult_0 ad_mult_Star->e_ECLK_flag
/* Output event macros */
#define emit_e_AD_END() ad_mult_Star->emitEventToIntQ( e_AD_END, _delay )
#define emit_e_ADR1() ad_mult_Star->emitEventToIntQ( e_ADR1, _delay )
#define emit_e_ADR2() ad_mult_Star->emitEventToIntQ( e_ADR2, _delay )
#define emit_e_ADR3() ad_mult_Star->emitEventToIntQ( e_ADR3, _delay )
#define emit_e_ADR4() ad_mult_Star->emitEventToIntQ( e_ADR4, _delay )
#define startup( p )
#define cleanup( p, e ) ad_mult_Star->CleanUp( e )
#define always_cleanup( p ) ad_mult_Star->CleanUp( 1 )
#define cpu ad_mult_Star->resourceId
#define SET_LT(a,b) ad_mult_Star->Set_LT((a),(b))
/* Settable constant macros */
/* State and output variable macros */
#define v__st ad_mult_Star->_st
#define v_count ad_mult_Star->count
    DEad_mult * ad_mult_Star = NULL;
    static int do_estimate = 1;
    static double _delay = 0.0;
    static double _cache_delay[56];
    /* Output event constants */
    static const int e_AD_END = 1;
    static const int e_ADR1 = 2;
    static const int e_ADR2 = 3;
    static const int e_ADR3 = 4;
    static const int e_ADR4 = 5;
    /* Input variable declarations */
    static int v_AD_START;
    static int v_PE0;
    static int v_PE1;
    static int v_PE2;
    static int v_PE3;
    static int v_PE4;
    static int v_PE5;
    static int v_PE6;
    static int v_PE7;
    /* Output variable declarations */
    static int v_ADR1;
    static int v_ADR2;
    static int v_ADR3;
    static int v_ADR4;

    static unsigned int path_id;
#include "z_ad_mult_0.c"

DEad_mult::DEad_mult ()
{
	setDescriptor("Star generated by POLIS\n68hc11:\n    min_time: 269\n    max_time: 796\n    tot_size: 1081");
	addPort(e_AD_START.setPort("e_AD_START",this,INT));
	addPort(e_ECLK.setPort("e_ECLK",this,INT));
	addPort(s_PE0.setPort("s_PE0",this,INT));
	addPort(s_PE1.setPort("s_PE1",this,INT));
	addPort(s_PE2.setPort("s_PE2",this,INT));
	addPort(s_PE3.setPort("s_PE3",this,INT));
	addPort(s_PE4.setPort("s_PE4",this,INT));
	addPort(s_PE5.setPort("s_PE5",this,INT));
	addPort(s_PE6.setPort("s_PE6",this,INT));
	addPort(s_PE7.setPort("s_PE7",this,INT));
	addPort(e_AD_END.setPort("e_AD_END",this,INT));
	addPort(e_ADR1.setPort("e_ADR1",this,INT));
	addPort(e_ADR2.setPort("e_ADR2",this,INT));
	addPort(e_ADR3.setPort("e_ADR3",this,INT));
	addPort(e_ADR4.setPort("e_ADR4",this,INT));
	addState(implem.setState("implem",this,"{implem}","Valid values: HW SW"));
	addState(resourceName.setState("resourceName",this,"Resource1","resource to be used for simulation"));
	addState(Clock_freq.setState("Clock_freq",this,"Clock_freq","CPU Clock frequency"));
	addState(policy.setState("policy",this,"{SCHEDULER}","Scheduling Policy to be used for simulation"));
	addState(Priority.setState("Priority",this,"0","Priority: 0 -> lower"));
	addState(firename.setState("firename",this,"{Firingfile}","File to write firing information",
# line 136 "DEad_mult.pl"
A_NONSETTABLE));
	addState(overname.setState("overname",this,"{Overflowfile}","File to write overflow information",
# line 143 "DEad_mult.pl"
A_NONSETTABLE));

# line 148 "DEad_mult.pl"
delayType = TRUE;
    _delay = 0.0;
}

void DEad_mult::begin() {
# line 340 "DEad_mult.pl"
char stemp[ 1024 ];
    InfString name;
    int saveimpl;

    if ( needsSharedResource < 2 ) {
      priority = Priority;
      ad_mult_Star = this;
      /* set variables which reflect Star parameters*/
      strcpy( stemp, policy);
      schedPolicy = resourcePointer->getSchedPolicy( stemp );
      sprintf( stemp, "%d", priority );
      lastFiredPr = resourcePointer->registerPriority( stemp );
      clkFreq = Clock_freq;
      clkFreq = (1000000.0)*clkFreq;
      resourcePointer->registerClock( clkFreq );
      totnf = 1.0/clkFreq;
      emittedEvents = new SequentialList();
      storeList = new SequentialList();
      _delay = 0.0;
      int i;
      for ( i=0; i<=55; i++ ) {
         _cache_delay[i] = 0;
      }
      /* State and output variables initialization */
      _st = 0;
      /* Settable constants initialization */
      /* Input event flag initialization */
      e_AD_START_flag = 0;
      e_ECLK_flag = 0;
      if ( needsSharedResource ) {
        strcpy( stemp, resource );
        if (strchr(stemp, '.')) *(strchr(stemp,'.')) = '\0';
        if (( resourceId = (int) ReadCostParam( stemp )) == -1 ) {
          strcat( stemp, ": not a valid CPU" );
          Error::abortRun( *this, stemp );
        }
      }
      strcpy( stemp, firename );
      if (strcmp(stemp,"{Firingfile}")) fpfire = DERCStar::Openfiring(stemp);
      strcpy( stemp, overname );
      if (strcmp(stemp,"{Overflowfile}")) fpover = DERCStar::Openoverflow(stemp);
      now = -1.0;
      saveimpl = needsSharedResource;
      needsSharedResource = 0;
      _t_z_ad_mult_0(0,0);

      needsSharedResource = saveimpl;
    } else {
      strcpy( stemp, "Implementation not supported!" );
      Error::abortRun( *this, stemp );
    }
}

void DEad_mult::setup() {
# line 321 "DEad_mult.pl"
DETarget *t;
    char stemp[1024];

    t = (DETarget *) target();
    if (!(t->isResource())) {
      strcpy( stemp, "Please, set target to Resource Contention Scheduler" );
      Error::abortRun( *this, stemp );
    }
    timeOfArrival = -1;
    _nextf = 1.0;
    _latency = 1.0;
    DERCStar::Closeflow();
    strcpy(resource, resourceName);
    strcpy(stemp, implem);
    needsSharedResource = getImplem( stemp );
    if ( needsSharedResource < 2 ) {
    }
}

void DEad_mult::go() {
# line 393 "DEad_mult.pl"
char stemp[ 1024 ];
    int runflag = 0;
    StringList name;

    now = arrivalTime;
    name = Block::fullName();
    ad_mult_Star = this;
    if (feedbackIn->dataNew && (int)((*feedbackIn)%0) == 0) {
        DERCStar* starUsingResource = resourcePointer->getTopCell()->star;
        if (((StarLLCell*)emittedEvents->head())->time != now ) {
            refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0);
        } else {
            if ( starUsingResource != this ) {
                Error::abortRun( *this, "Star should not reach this point if preempted!" );
            }
            if(emittedEvents->head() == emittedEvents->tail() ) {
                // This is the dummy event indicating end of resource usage 
                resourcePointer->removeFinishedStar(this); 
                emittedEvents->getAndRemove(); 
                assert(emittedEvents->getAndRemove() == 0); 
                if ( fpfire ) {
                    sprintf( stemp, "%s: %f %d end %s\n", (const char*) name, now, priority, resource );
                    DERCStar::Printfiring( stemp );
                }
            } else { 
                StarLLCell *temp; 
                while((temp = (StarLLCell*)emittedEvents->head())->time == now && (emittedEvents->head() != emittedEvents->tail()) ) { 
                    StarLLCell *temp = (StarLLCell*)emittedEvents->getAndRemove(); 
                    assert(now == temp->time); 
                    emitEvent(temp, now); 
                } 
                refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
            }
            feedbackIn->dataNew = FALSE;
        }
    } else { // This star is firing for the first time, and has resource if req 
        if ( e_AD_START.dataNew ) {
          e_AD_START_flag = 1;
          e_AD_START.dataNew = FALSE;
          runflag = 1;
        }
        if ( e_ECLK.dataNew ) {
          e_ECLK_flag = 1;
          e_ECLK.dataNew = FALSE;
          runflag = 1;
        }

      // Read the input values 
      v_AD_START = (e_AD_START)%0;
      v_PE0 = (s_PE0)%0;
      v_PE1 = (s_PE1)%0;
      v_PE2 = (s_PE2)%0;
      v_PE3 = (s_PE3)%0;
      v_PE4 = (s_PE4)%0;
      v_PE5 = (s_PE5)%0;
      v_PE6 = (s_PE6)%0;
      v_PE7 = (s_PE7)%0;
      _delay = 0.0;
      if (runflag == 1) {
        _t_z_ad_mult_0(0,0);

        // write to firing file 
        if ( fpfire ) {
            sprintf( stemp, "%s: %f %d start %s\n", (const char*) name, now, priority, resource );
            DERCStar::Printfiring( stemp );
        }
        if (needsSharedResource) emitEventToIntQ( 0, _delay );// emit dummy event 
        timeOfArrival = -1;// reset this as have finished this firing 
        if (needsSharedResource) refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0);
      }
    }
}


int DEad_mult::emitEventToIntQ ( int outputPort, double delay )
{
# line 157 "DEad_mult.pl"
static const int ce_AD_END = 1;
      static const int ce_ADR1 = 2;
      static const int ce_ADR2 = 3;
      static const int ce_ADR3 = 4;
      static const int ce_ADR4 = 5;
      double emitTime;
      OutDEPort* tl;
      if (needsSharedResource) {
           StarLLCell *temp = (StarLLCell*)storeList->getAndRemove();
           if (temp == 0) temp = new StarLLCell(-1, -1);
           emitTime = now + (delay/clkFreq);
           temp->time = emitTime;
           temp->outputPort = outputPort;
           emittedEvents->append(temp);
      } else {
           if (now < 0) emitTime = 0.0;
           else emitTime = now + (_latency/clkFreq);
           switch(outputPort) {
             case ce_AD_END:
                tl = & e_AD_END;
                tl->put(emitTime) << 1;
                break;
             case ce_ADR1:
                tl = & e_ADR1;
                tl->put(emitTime) << v_ADR1;
                break;
             case ce_ADR2:
                tl = & e_ADR2;
                tl->put(emitTime) << v_ADR2;
                break;
             case ce_ADR3:
                tl = & e_ADR3;
                tl->put(emitTime) << v_ADR3;
                break;
             case ce_ADR4:
                tl = & e_ADR4;
                tl->put(emitTime) << v_ADR4;
                break;
            default:
               break;
         }
      }
      return 1;
}


void DEad_mult::emitEvent (StarLLCell* cell, double emitTime)
{
# line 208 "DEad_mult.pl"
static const int ce_AD_END = 1;
      static const int ce_ADR1 = 2;
      static const int ce_ADR2 = 3;
      static const int ce_ADR3 = 4;
      static const int ce_ADR4 = 5;
      OutDEPort * tl;
      switch( cell->outputPort ) {
            case ce_AD_END:
                tl = & e_AD_END;
                tl->put(emitTime) << 1;
                break;
            case ce_ADR1:
                tl = & e_ADR1;
                tl->put(emitTime) << v_ADR1;
                break;
            case ce_ADR2:
                tl = & e_ADR2;
                tl->put(emitTime) << v_ADR2;
                break;
            case ce_ADR3:
                tl = & e_ADR3;
                tl->put(emitTime) << v_ADR3;
                break;
            case ce_ADR4:
                tl = & e_ADR4;
                tl->put(emitTime) << v_ADR4;
                break;
            default:
               break;
      }
      storeList->append(cell);
}


double DEad_mult::getDelay ()
{
# line 247 "DEad_mult.pl"
// need to add 1 clock cycle for SW stars so that dummy event is seen
      if (needsSharedResource) return (_delay)/clkFreq;// FIXME: a hack
      else return (totnf);
}


void DEad_mult::CleanUp ( int emitted )
{
# line 258 "DEad_mult.pl"
if ( emitted ) {
        e_AD_START_flag = 0;
        e_ECLK_flag = 0;
      }
}


// prototype instance for known block list
static DEad_mult proto;
static RegisterBlock registerBlock(proto,"ad_mult");
