#ifndef _DEad_scan_mult_h
#define _DEad_scan_mult_h 1
// header file generated from DEad_scan_mult.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "uC_types.h"
#include "swlib.h"
#include "DETarget.h"
#include "DEPolis.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"

class DEad_scan_mult : public DEPolis
{
public:
	DEad_scan_mult();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void begin();
	InDEPort e_AD_START;
	InDEPort e_ECLK;
	InDEPort s_PE0;
	InDEPort s_PE1;
	InDEPort s_PE2;
	InDEPort s_PE3;
	InDEPort s_PE4;
	InDEPort s_PE5;
	InDEPort s_PE6;
	InDEPort s_PE7;
	OutDEPort e_AD_END;
	OutDEPort e_ADR1;
	OutDEPort e_ADR2;
	OutDEPort e_ADR3;
	OutDEPort e_ADR4;
# line 84 "DEad_scan_mult.pl"
double now;
    int resourceId;
    double clkFreq;
    /* Input event flags */
    int e_AD_START_flag;
    int e_ECLK_flag;
    /* Settable constants */
    /* State and output variables */
    int _st;
    int count;
	int emitEventToIntQ ( int outputPort, double delay );
	void emitEvent (StarLLCell* cell, double emitTime);
	double getDelay ();
	void CleanUp ( int emitted );

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState implem;
	StringState resourceName;
	FloatState Clock_freq;
	StringState policy;
	IntState Priority;
	StringState firename;
	StringState overname;

private:
# line 96 "DEad_scan_mult.pl"
double *_time, totnf;
    double _nextf, _latency;
    FILE *fpfire;
    FILE *fpover;

};
#endif
