#ifndef _DEfrc_h
#define _DEfrc_h 1
// header file generated from DEfrc.pl by ptlang

#ifdef __GNUG__
#pragma interface
#endif

#include "uC_types.h"
#include "swlib.h"
#include "DETarget.h"
#include "DEPolis.h"
#include "IntState.h"
#include "FloatState.h"
#include "StringState.h"

class DEfrc : public DEPolis
{
public:
	DEfrc();
	/* virtual */ Block* makeNew() const;
	/* virtual*/ const char* className() const;
	/* virtual*/ int isA(const char*) const;
	/* virtual */ void begin();
	InDEPort e_ECLK;
	OutDEPort e_TCLK;
# line 24 "DEfrc.pl"
double now;
    int resourceId;
    double clkFreq;
    /* Input event flags */
    int e_ECLK_flag;
    /* Settable constants */
    int c_MAXCOUNT;
    int c_SIMSCALE;
    int c_PRESCALER;
    /* State and output variables */
    int _st;
    int COUNT;
    int SCALE;
	int emitEventToIntQ ( int outputPort, double delay );
	void emitEvent (StarLLCell* cell, double emitTime);
	double getDelay ();
	void CleanUp ( int emitted );

protected:
	/* virtual */ void setup();
	/* virtual */ void go();
	StringState implem;
	StringState resourceName;
	FloatState Clock_freq;
	StringState policy;
	IntState Priority;
	StringState firename;
	StringState overname;
	IntState MAXCOUNT;
	IntState SIMSCALE;
	IntState PRESCALER;

private:
# line 39 "DEfrc.pl"
double *_time, totnf;
    double _nextf, _latency;
    FILE *fpfire;
    FILE *fpover;
    /* Variables for behavioral simulation */
    int started;
    double valuein;

};
#endif
