static const char file_id[] = "DEoc_self.pl";
// .cc file generated from DEoc_self.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEoc_self.h"
#include "InfString.h"

const char *star_nm_DEoc_self = "DEoc_self";

const char* DEoc_self :: className() const {return star_nm_DEoc_self;}

ISA_FUNC(DEoc_self,DEPolis);

Block* DEoc_self :: makeNew() const { LOG_NEW; return new DEoc_self;}

# line 199 "DEoc_self.pl"
#define DO_ESTIMATE  (do_estimate=1)
#define DO_NOT_ESTIMATE  (do_estimate=0)
#define illegal_cpu() 0
#define FUZZY(n,d) {if ((oc_self_Star->needsSharedResource)&&(do_estimate)) { \
                     _delay += _cache_delay[n]?_cache_delay[n]:_cache_delay[n]=oc_self_Star->FuzzyDelay(d); \
                 }}
#define ENERGY(e)
#define DELAY(d) {if ((oc_self_Star->needsSharedResource)&&(do_estimate)) {_delay += (d);}}
/* Input event macros */
#define detect_e_RESET_to_z_oc_self_0 oc_self_Star->e_RESET_flag
#define detect_e_TCLK_to_z_oc_self_0 oc_self_Star->e_TCLK_flag
/* Output event macros */
#define emit_e_OC_END() oc_self_Star->emitEventToIntQ( e_OC_END, _delay )
#define startup( p )
#define cleanup( p, e ) oc_self_Star->CleanUp( e )
#define always_cleanup( p ) oc_self_Star->CleanUp( 1 )
#define cpu oc_self_Star->resourceId
#define SET_LT(a,b) oc_self_Star->Set_LT((a),(b))
/* Settable constant macros */
#define v_SIMSCALE oc_self_Star->c_SIMSCALE
#define v_N oc_self_Star->c_N
#define v_OCPERIOD oc_self_Star->c_OCPERIOD
#define v_MAXCOUNT oc_self_Star->c_MAXCOUNT
/* State and output variable macros */
#define v__st oc_self_Star->_st
#define v_COUNT_OC oc_self_Star->COUNT_OC
    DEoc_self * oc_self_Star = NULL;
    static int do_estimate = 1;
    static double _delay = 0.0;
    static double _cache_delay[11];
    /* Output event constants */
    static const int e_OC_END = 1;
    /* Input variable declarations */
    static int v_TCLK;
    /* Output variable declarations */

    static unsigned int path_id;
#include "z_oc_self_0.c"

DEoc_self::DEoc_self ()
{
	setDescriptor("Self Triggering Output Compare");
	addPort(e_RESET.setPort("e_RESET",this,INT));
	addPort(e_TCLK.setPort("e_TCLK",this,INT));
	addPort(e_OC_END.setPort("e_OC_END",this,INT));
	addState(implem.setState("implem",this,"{implem}","Valid values: HW SW BEHAV"));
	addState(resourceName.setState("resourceName",this,"Resource1","resource to be used for simulation"));
	addState(Clock_freq.setState("Clock_freq",this,"Clock_freq","CPU Clock frequency"));
	addState(policy.setState("policy",this,"{SCHEDULER}","Scheduling Policy to be used for simulation"));
	addState(Priority.setState("Priority",this,"0","Priority: 0 -> lower"));
	addState(firename.setState("firename",this,"{Firingfile}","File to write firing information",
# line 85 "DEoc_self.pl"
A_NONSETTABLE));
	addState(overname.setState("overname",this,"{Overflowfile}","File to write overflow information",
# line 92 "DEoc_self.pl"
A_NONSETTABLE));
	addState(SIMSCALE.setState("SIMSCALE",this,"1","Scale down simulation (only for HW and SW)"));
	addState(N.setState("N",this,"1","Parameter N (range 1 to 5) identifies one of the 5 output compares"));
	addState(OCPERIOD.setState("OCPERIOD",this,"256","Number of FRC ticks to count"));
	addState(MAXCOUNT.setState("MAXCOUNT",this,"MAXCOUNT","Maximum value of the FRC counter"));

# line 121 "DEoc_self.pl"
delayType = TRUE;
    _delay = 0.0;
}

void DEoc_self::begin() {
# line 258 "DEoc_self.pl"
char stemp[ 1024 ];
    InfString name;
    int saveimpl;

    if ( needsSharedResource < 2 ) {
      priority = Priority;
      oc_self_Star = this;
      /* set variables which reflect Star parameters*/ 
      strcpy( stemp, policy); 
      schedPolicy = resourcePointer->getSchedPolicy( stemp );
      sprintf( stemp, "%d", priority );
      lastFiredPr = resourcePointer->registerPriority( stemp );
      clkFreq = Clock_freq;
      clkFreq = (1000000.0)*clkFreq;
      resourcePointer->registerClock( clkFreq );
      totnf = 1.0/clkFreq;
      emittedEvents = new SequentialList();
      storeList = new SequentialList();
      _delay = 0.0;
      int i;
      for ( i=0; i<=10; i++ ) {
         _cache_delay[i] = 0;
      }
      /* State and output variables initialization */
      _st = 0;
      /* Settable constants initialization */
      c_SIMSCALE = SIMSCALE;
      c_N = N;
      c_OCPERIOD = OCPERIOD;
      c_MAXCOUNT = MAXCOUNT;
      /* Input event flag initialization */
      e_RESET_flag = 0;
      e_TCLK_flag = 0;
      if ( needsSharedResource ) {
        strcpy( stemp, resource );
        if (strchr(stemp, '.')) *(strchr(stemp,'.')) = '\0';
        if (( resourceId = (int) ReadCostParam( stemp )) == -1 ) {
          strcat( stemp, ": not a valid CPU" );
          Error::abortRun( *this, stemp );
        }
      }
      strcpy( stemp, firename );
      if (strcmp(stemp,"{Firingfile}")) fpfire = DERCStar::Openfiring(stemp);
      strcpy( stemp, overname );
      if (strcmp(stemp,"{Overflowfile}")) fpover = DERCStar::Openoverflow(stemp);
      now = -1.0;
      saveimpl = needsSharedResource;
      needsSharedResource = 0;
      _t_z_oc_self_0(0,0);

      needsSharedResource = saveimpl;
    } else if ( needsSharedResource == 2 ) {
      nextf = 0.0;
      ncycle = 0;
      ckfr = (double) Clock_freq;
    } else {
      strcpy( stemp, "Implementation not supported!" );
      Error::abortRun( *this, stemp );
    }
}

void DEoc_self::setup() {
# line 239 "DEoc_self.pl"
DETarget *t;
    char stemp[1024];

    t = (DETarget *) target();
    if (!(t->isResource())) {
      strcpy( stemp, "Please, set target to Resource Contention Scheduler" );
      Error::abortRun( *this, stemp );
    }
    timeOfArrival = -1;
    _nextf = 1.0;
    _latency = 1.0;
    DERCStar::Closeflow();
    strcpy(resource, resourceName);
    strcpy(stemp, implem);
    needsSharedResource = getImplem( stemp );
    if ( needsSharedResource < 2 ) {
    }
}

void DEoc_self::go() {
# line 319 "DEoc_self.pl"
char stemp[ 1024 ];
    int runflag = 0;
    StringList name;
    int refire;
    
    now = arrivalTime;
    if ( needsSharedResource < 2 ) {
      name = Block::fullName();
      oc_self_Star = this;
      if (feedbackIn->dataNew && (int)((*feedbackIn)%0) == 0) {
          DERCStar* starUsingResource = resourcePointer->getTopCell()->star;
          if (((StarLLCell*)emittedEvents->head())->time != now ) {
              refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0);
          } else {
              if ( starUsingResource != this ) {
                  Error::abortRun( *this, "Star should not reach this point if preempted!" );
              }
              if(emittedEvents->head() == emittedEvents->tail() ) {
                  // This is the dummy event indicating end of resource usage 
                  resourcePointer->removeFinishedStar(this); 
                  emittedEvents->getAndRemove(); 
                  assert(emittedEvents->getAndRemove() == 0); 
                  if ( fpfire ) {
                      sprintf( stemp, "%s: %f %d end %s\n", (const char*) name, now, priority, resource );
                      DERCStar::Printfiring( stemp );
                  }
              } else { 
                  StarLLCell *temp; 
                  while((temp = (StarLLCell*)emittedEvents->head())->time == now && (emittedEvents->head() != emittedEvents->tail()) ) { 
                      StarLLCell *temp = (StarLLCell*)emittedEvents->getAndRemove(); 
                      assert(now == temp->time); 
                      emitEvent(temp, now); 
                  } 
                  refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
              }
              feedbackIn->dataNew = FALSE;
          }
      } else { // This star is firing for the first time, and has resource if req 
          if ( e_RESET.dataNew ) {
            e_RESET_flag = 1;
            e_RESET.dataNew = FALSE;
            runflag = 1;
          }
          if ( e_TCLK.dataNew ) {
            e_TCLK_flag = 1;
            e_TCLK.dataNew = FALSE;
            runflag = 1;
          }

        // Read the input values 
        v_TCLK = (e_TCLK)%0;
        _delay = 0.0;
        if (runflag == 1) {
          _t_z_oc_self_0(0,0);

          // write to firing file 
          if ( fpfire ) {
              sprintf( stemp, "%s: %f %d start %s\n", (const char*) name, now, priority, resource );
              DERCStar::Printfiring( stemp );
          }
          if (needsSharedResource) emitEventToIntQ( 0, _delay );// emit dummy event 
          timeOfArrival = -1;// reset this as have finished this firing 
          if (needsSharedResource) refireAtTime(((StarLLCell*)emittedEvents->head())->time, 0.0); 
        }
      }
    } else if ( needsSharedResource == 2 ) {
      refire = ( canGetFired() ? 1 : 0 );
      if ( e_RESET.dataNew ) {
        nextf = 0.0;
        while ( e_RESET.dataNew ) e_RESET.getSimulEvent();
      }
      if ( e_TCLK.dataNew ) {
        ncycle = (e_TCLK)%0;
        while ( e_TCLK.dataNew ) e_TCLK.getSimulEvent();
      }
      if ( ncycle > 0 && ( OCPERIOD % MAXCOUNT ) > 0 ) {
        if ( refire && nextf == now ) {
          refire = 0;
          e_OC_END.put( now ) << (int) 1;
        }
        nextf = ( OCPERIOD % MAXCOUNT ) * ncycle / (ckfr*1000000.0) + now;
        refireAtTime( nextf );
      }
    }
}


int DEoc_self::emitEventToIntQ ( int outputPort, double delay )
{
# line 130 "DEoc_self.pl"
static const int ce_OC_END = 1;
      double emitTime;
      OutDEPort* tl;
      if (needsSharedResource) {
           StarLLCell *temp = (StarLLCell*)storeList->getAndRemove();
           if (temp == 0) temp = new StarLLCell(-1, -1);
           emitTime = now + (delay/clkFreq);
           temp->time = emitTime;
           temp->outputPort = outputPort;
           emittedEvents->append(temp);
      } else {
           if (now < 0) emitTime = 0.0;
           else emitTime = now + (_latency/clkFreq);
           switch(outputPort) {
             case ce_OC_END:
                tl = & e_OC_END;
                tl->put(emitTime) << 1;
                break;
            default:
               break;
         }
      }
      return 1;
}


void DEoc_self::emitEvent (StarLLCell* cell, double emitTime)
{
# line 161 "DEoc_self.pl"
static const int ce_OC_END = 1;
      OutDEPort * tl;
      switch( cell->outputPort ) {
            case ce_OC_END:
                tl = & e_OC_END;
                tl->put(emitTime) << 1;
                break;
            default:
               break;
      }
      storeList->append(cell);
}


double DEoc_self::getDelay ()
{
# line 180 "DEoc_self.pl"
// need to add 1 clock cycle for SW stars so that dummy event is seen
      if (needsSharedResource) return (_delay)/clkFreq;// FIXME: a hack
      else return (totnf);
}


void DEoc_self::CleanUp ( int emitted )
{
# line 192 "DEoc_self.pl"
if ( emitted ) {
        e_RESET_flag = 0;
        e_TCLK_flag = 0;
      }
}


// prototype instance for known block list
static DEoc_self proto;
static RegisterBlock registerBlock(proto,"oc_self");
