static const char file_id[] = "DEdpmemory.pl";
// .cc file generated from DEdpmemory.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEdpmemory.h"

const char *star_nm_DEdpmemory = "DEdpmemory";

const char* DEdpmemory :: className() const {return star_nm_DEdpmemory;}

ISA_FUNC(DEdpmemory,DEStar);

Block* DEdpmemory :: makeNew() const { LOG_NEW; return new DEdpmemory;}

DEdpmemory::DEdpmemory ()
{
	setDescriptor("Polis double port memory");
	addPort(RESET.setPort("RESET",this,INT));
	addPort(WRITE_ADDR.setPort("WRITE_ADDR",this,INT));
	addPort(READ_ADDR.setPort("READ_ADDR",this,INT));
	addPort(DATA_IN.setPort("DATA_IN",this,INT));
	addPort(DATA_OUT.setPort("DATA_OUT",this,INT));
	addState(memsize.setState("memsize",this,"1","Memory size (in number of int values)"));

# line 41 "DEdpmemory.pl"
delayType = TRUE;
}

void DEdpmemory::begin() {
# line 44 "DEdpmemory.pl"
char stemp[ 1024 ];
		extern void * calloc (int, int);
        if (( data = (int *) calloc( sizeof( int ), memsize )) == NULL ) {
            strcpy( stemp, "Cannot allocate memory" );
            Error::abortRun( *this, stemp );
        }
}

void DEdpmemory::go() {
# line 52 "DEdpmemory.pl"
int addr, val;
        char stemp[ 1024 ];
        
        if ( RESET.dataNew ) {
            while ( RESET.dataNew ) RESET.getSimulEvent();
            while ( READ_ADDR.dataNew ) READ_ADDR.getSimulEvent();
            while ( WRITE_ADDR.dataNew ) WRITE_ADDR.getSimulEvent();
            while ( DATA_IN.dataNew ) DATA_IN.getSimulEvent();
        } else {
            if ( READ_ADDR.dataNew ) {
                addr = (READ_ADDR)%0;
                while ( READ_ADDR.dataNew ) READ_ADDR.getSimulEvent();
                if ( addr < 0 || addr > memsize - 1 ) {
                    sprintf( stemp, "Read out of bound at memory address %d", addr );
                    Error::abortRun( *this, stemp );
                }   
                val = data[ addr ];
                DATA_OUT.put( arrivalTime + 1.0 ) << val;
            }
            if ( WRITE_ADDR.dataNew ) {
                if ( DATA_IN.dataNew ) {
                    addr = (WRITE_ADDR)%0;
                    val = (DATA_IN)%0;
                    while ( WRITE_ADDR.dataNew ) WRITE_ADDR.getSimulEvent();
                    while ( DATA_IN.dataNew ) DATA_IN.getSimulEvent();
                    if ( addr < 0 || addr > memsize - 1 ) {
                        sprintf( stemp, "Write out of bound at memory address %d", addr );
                        Error::abortRun( *this, stemp );
                    }
                    data[ addr ] = val;
                }
            }
        }
}

// prototype instance for known block list
static DEdpmemory proto;
static RegisterBlock registerBlock(proto,"dpmemory");
