static const char file_id[] = "DEAbsclock.pl";
// .cc file generated from DEAbsclock.pl by ptlang

#ifdef __GNUG__
#pragma implementation
#endif

#include "DEAbsclock.h"

const char *star_nm_DEAbsclock = "DEAbsclock";

const char* DEAbsclock :: className() const {return star_nm_DEAbsclock;}

ISA_FUNC(DEAbsclock,DERepeatStar);

Block* DEAbsclock :: makeNew() const { LOG_NEW; return new DEAbsclock;}

DEAbsclock::DEAbsclock ()
{
	setDescriptor("Generate events every x milliseconds, starting at time zero.\n               Need a universe parameter called Clock_freq, in Mhz.");
	addPort(output.setPort("output",this,FLOAT));
	addState(interval.setState("interval",this,"1.0","The interval of events, in milliseconds."));
	addState(magnitude.setState("magnitude",this,"1.0","The value of the output particles generated."));
	addState(frequency.setState("frequency",this,"Clock_freq","Clock frequency of the processor",
# line 29 "DEAbsclock.pl"
A_NONSETTABLE));


}

void DEAbsclock::go() {
# line 32 "DEAbsclock.pl"
// Generate the output event
	   // (Recall that the first event comes out at time 0).
	   output.put( completionTime ) << double( magnitude );

	   // and schedule the next firing
	   completionTime += interval * frequency * 1000;
	   refireAtTime((int) completionTime );
}

// prototype instance for known block list
static DEAbsclock proto;
static RegisterBlock registerBlock(proto,"Absclock");
